/*!
  * Licensed Materials - Property of IBM
  * 5725N95, 5725P55, 5725N96
  * (C) Copyright IBM Corp. 1999, 2014.
  * US Government Users Restricted Rights- Use, duplication or disclosure
  * restricted by GSA ADP Schedule Contract with IBM Corp.
 */

 /* $Id$ */
 
function formatScore(score)
{
    return formatTwoDecimal(score);
}

/**
 * Generates the score of the specified assessment and displays it's
 * summary in an HTML page
 */
AssessmentUI.showReport = function(type, args, me)
{
	var assessment = AssessmentEngine.assessment;

	var yd = YAHOO.util.Dom;
	
	var assessment_percent= (1.2)*(assessment.getScore() * 100);

    var s = "<html><head><title>Assessment Results</title>";
		s += "<link rel=\"stylesheet\" href=\""+AssessmentUI.detailsStyleSheet+"\"></link>";
		s += "</head><body>";
		s += "<div id=\"header\">";
		s += "<h1 id=\"objectLabel\">Assessment Results</h1>";
		s += "</div>";
		s += "<div id=\"content\">";
		s += "<div id=\"score\">Score:" + formatScore((assessment.getScore() * 100)) + " %</div>";

	if (!assessment.ignoreSections)
	{
	    // iterate thru all sections in the assessment
	    var sections = assessment.children;
	    var count = 0;
	    var sumSWA = 0;
	    var sumSWP = 0;

	    for (var j=0; j<sections.length; j++)
	    {
	        var section = sections[j];
			
			var section_percent   = (1.2)*(section.getScore() * 100);
			
			if (sections.length > 1)
			{
				s += "<h2 class=\"sectionLabel\">Section: " + unescape(section.getLabel()) + "</h2>";
			}

			s += "<table class=\"resultsdetailtable\" border=1 cellpadding=3 cellspacing=1 summary=\"Assessment Details\">\n";
		    s += "<tr><th id='stemheading' scope='col' width='90%'>Question</th><th id='scoreheading' scope='col'>Score</th></tr>\n";
			s += addQuestionsToSummary(section.children,count);
	        s += "</table>";

	        sumSWA += section.getScore() * section.getWeight();
	        sumSWP += section.getWeight();
	    }
	}
	else
	{
		s += "<table class=\"resultsdetailtable\" border=1 cellpadding=3 cellspacing=1 summary=\"Assessment Details\">\n";
		s += "<tr><th id='stemheading' scope='col' width='90%'>Question</th><th id='scoreheading' scope='col'>Score</th></tr>\n";
		s += addQuestionsToSummary(assessment.children,count);
		s += "</table>";
	}

	//Duc added case #28953 - LCMS Score Details Screen - Print Button missing in static html
	s += "<BR><BR><form><div align=center>";
	s += "<input type=button value='Close' class='assessmentbuttonstyle' onClick='var w=window,i=0;while(i++<20){w.close();if(w==w.parent)break;w=w.parent}return false;'>\n";
	s += "&nbsp;&nbsp;<input title='Print' value='Print' class='assessmentbuttonstyle' name='print' onclick='window.print();' type='button'/>";
	s += "</div></form>";

	s += "</div>";
	s += "</body></html>";
	
	document.open();
	document.write(s);
	document.close();
	
	// bump the window so the screen reader updates
	window.focus();
}

AssessmentEngine.events.scoreComplete.subscribe(AssessmentUI.showReport);

function addQuestionsToSummary(questions,count)
{
	var summary = "";

	for(var k=0; k<questions.length; k++)
	{
		count++;
		var question = questions[k];
		var score = question.getScore();
		var raw_actual = Math.max(0, score.getTotalCorrect() - score.getTotalIncorrect());
		var raw_possible = score.getQuestionValue();
		var weighted_actual = raw_actual * question.getWeight();
		var weighted_possible = raw_possible * question.getWeight();
		var weighted_percent = raw_actual / raw_possible * 100;
		var width_percent     = (1.2)* weighted_percent;
		
		var scorevalue = score.getScore();

		var contentStem = unescape(question.description);
		if (question.type == "109")
		{
			// this is for viewing CMI details
			contentStem = "<a target=cmidetail href=\"\" onClick=\"javascript:NewCMIDetail('"+question.getContentID()+"', '"+question.getContentID()+"', '"+ contentStem+"', 'true');return false;\" >"+contentStem+"</a>";
		}
		else if (question.type == "103")
		{
			weighted_actual = weighted_actual / weighted_possible;
		}

		summary += "<tr><td scope='row' class='ad-bodystyle'><span class='ad-contentdescstyle'>"+contentStem + "</span></td>";
		summary += "<td class='ad-bodystyle' align=right><span class='ad-contentdescstyle'>" + formatScore((scorevalue*100)) + " %</span></td>";
		summary += "</tr>\n";
	}
	
	return summary;
}